(*
    
    
    
    
                                                  
                                                      
       Unit was conceived, designed and written         
       by Floor A.C. Naaijkens for                      
       UltiHouse Software / The ECO Group.              
                                                        
       (C) MCMXCII by EUROCON PANATIONAL CORPORATION.   
       All Rights Reserved for The ECO Group.           
                                                        
                                                      
                                                  
    
    
    
    
*)
unit eco_vprm;
interface
uses
  graph, eco_gdrv;


procedure get_video_params;
var i: sint;
begin
  allowlines[1] := true;
  for i := 2 to 4 do allowlines[i] := false;
  if _monoadapter<>_absent then herc_present := true else herc_present := false;
  if _coloradapter <> _absent then cga_present := true else cga_present := false;
  if _egaadapter <> _absent then begin
    ega_present := true; allowlines[_43]:= true
  end else ega_present := false;
  if _hercadapter <> _absent then herc_present := true else herc_present := false;
  if _mcgaadapter <> _absent then begin
    vga_present := true; allowlines[_30] := true
  end else vga_present := false;
  if _vgaadapter <> _absent then begin
    vga_present := true;
    allowlines[_30] := true;
    allowlines[_43] := true;
    allowlines[_50] := true
  end else vga_present := false;
  if herc_present then begin
    if registerbgidriver(@hercdriverproc)>0 then warningbeep else begin
      writeln(retmsg(745)); delay(pause)
    end;
  end;
  if cga_present then begin
    if registerbgidriver(@cgadriverproc)>0 then warningbeep else begin
      writeln(retmsg(746)); delay(pause);
      if registerbgidriver(@attdriverproc)>0 then begin
        writeln(retmsg(747)); delay(pause)
      end else begin
        writeln(' No ATT present, CGA detected, though.');
        warningbeep
      end;
    end;
  end;
  if ega_present then begin
    if registerbgidriver(@egavgadriverproc)>0 then warningbeep;
    writeln(retmsg(748)+'  <EGA> Enabled'); delay(pause);
  end;
  if vga_present then begin
    if registerbgidriver(@egavgadriverproc)>0 then warningbeep else
    writeln(retmsg(748)+'  <VGA> Enabled'); delay(pause);
    if registerbgidriver(@pc3270driverproc)>0 then warningbeep else
    writeln(retmsg(749));
  end;
  delay(pause); writeln(retmsg(750)); delay(pause);
  writeln(retmsg(751)); delay(pause); writeln(retmsg(752)); delay(pause);
  writeln(retmsg(753)); delay(pause+pause);
end;


begin

end.
